<?php

namespace App\Models\Equipment;

use App\Entities\Equipment\CodeEntity;

class CodeModel extends EquipmentModel
{
    const TABLE = "codeinfo";
    const PK = "uid";
    const TITLE = "code";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = CodeEntity::class;
    protected $allowedFields = [
        "code",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "code":
                $rule = "required|trim|min_length[4]|max_length[20]";
                $rule .= in_array($action, ["create", "create_form"]) ? "|is_unique[{$this->table}.{$field}]" : "";
                break;
            case "status":
                $rule  = "required|trim|string";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
}
